
package de.ivu.elect.presentation.gruppe.table;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.ergebnis.entity.Ergebnisart;
import de.ivu.elect.business.gruppe.boundary.GruppeKumulierteStimmenSearchParameters;
import de.ivu.elect.business.gruppe.entity.GruppeKumulierteStimmen;
import de.ivu.elect.business.stimmeingabe.control.StimmeingabeGruppeStimmenErfassenLabelGeneratorFinder;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.jee.presentation.dynamictable.ColumnGroup;

@Named(GruppeKumulierteStimmenColumnBuilder.COMPONENT_NAME)
public class GruppeKumulierteStimmenColumnBuilder extends AbstractGruppeStimmenColumnBuilder {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gruppeKumulierteStimmenColumnBuilder";

  @Inject
  @ConversationGroup(GruppeKumulierteStimmenSearchParameters.class)
  private transient GruppeKumulierteStimmenSearchParameters searchParameters;

  @Inject
  private transient StimmeingabeGruppeStimmenErfassenLabelGeneratorFinder stimmeingabeGruppeStimmenErfassenLabelGeneratorFinder;

  private AbstractGruppeKumulierteStimmenColumn gruppenPositionColumn;

  private AbstractGruppeKumulierteStimmenColumn gruppenKennungColumn;

  private ColumnGroup<GruppeKumulierteStimmen> positionGroup;

  private ColumnGroup<GruppeKumulierteStimmen> kennungGroup;

  private ColumnGroup<GruppeKumulierteStimmen> farbeGroup;

  private ColumnGroup<GruppeKumulierteStimmen> nameGroup;

  public GruppeKumulierteStimmenColumnBuilder() {
    super();
  }

  @Override
  protected void initColumns() {
    gruppenPositionColumn = new GruppeKumulierteStimmenGruppenPositionColumn(getMessages());
    gruppenKennungColumn = new GruppeKumulierteStimmenGruppenKennungColumn(getMessages());

    super.initColumns();
  }

  @Override
  protected void initColumnGroups() {
    positionGroup = createSingleColumnColumnGroup(gruppenPositionColumn);
    kennungGroup = createSingleColumnColumnGroup(gruppenKennungColumn);
    farbeGroup = createSingleColumnColumnGroup(gruppenFarbeColumn);
    nameGroup = createSingleColumnColumnGroup(gruppenNameColumn);

    super.initColumnGroups();
  }

  @Override
  protected List<ColumnGroup< ? super GruppeKumulierteStimmen>> getColumnGroupsSorted() {
    List<ColumnGroup< ? super GruppeKumulierteStimmen>> result = new ArrayList<>();

    if (isWahlMitGruppenKennung()) {
      result.add(kennungGroup);
    } else {
      result.add(positionGroup);
    }

    result.add(farbeGroup);
    result.add(nameGroup);
    result.addAll(super.getColumnGroupsSorted());

    return result;
  }

  @Override
  protected Ergebnisart getErgebnisartFuerDifferenz() {
    return searchParameters.getErgebnisartFuerDifferenz();
  }

  private boolean isWahlMitGruppenKennung() {
    Wahl wahl = getSelectedWahl();

    if (wahl == null) {
      return false;
    }

    return stimmeingabeGruppeStimmenErfassenLabelGeneratorFinder.getStimmeingabeGruppeStimmenErfassenLabelGeneratorFuerWahl(wahl).isGruppeHatKennung();
  }
}
